<!DOCTYPE html>
<html lang="">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>p5.js example</title>
  <style>
    body {
      padding: 0;
      margin: 0;
    }
  </style>
  <script src="p5.js"></script>
  <script src="p5.sound.js"></script>
  <script src="p5.sound.min.js"></script>
</head>

<body>
  <main>
    <a href="index.html">Zur Applikation</a>
    <p>
        <b>Technisch:</b><br>
        <b>Math-Bibliothek:</b> Wurde genutzt, um eine zufällige Generierung als Input aus einem Array mit manuell vorgefertigten richtigen/falschen Eingaben auszuwählen.<br>
        <b>p5.js:</b> Mithilfe von p5.js wurden die Canvas-Elemente eingefügt.
    </p> 
    <p>
        <b>Fachlich:</b>
        <br>
        <code>
          <font color="blue">// Vorbereitung</font><br>
          var zeichen = ""; <font color="blue">// Außerhalb der Funktionen deklariert, damit jede Funktion die Variable bearbeiten und lesen kann </font><br><br>

          <font color="blue">// Algorithmus</font><br>
          <font color="blue">// Beispiel q0. Falls in der aktuellen Position (=0) im String "zeichen", was unser Input ist, ein 'B' gelesen wird, dann wird die Bedingung erfüllt, falls nicht, wird entsprechend markiert.</font><br>
          <font color="blue">// Async-Funktion, damit ein await-Call aufgerufen werden kann.</font><br>
          async function nodeQ0(pos){<br>
          <font color="blue">// Markiert Knoten q0 im Graphen</font><br>
          markQ(0, true);<br>
          await sleep(500);<br>
          <font color="blue">// Der Schreib-/Lesekopf wird in die entsprechende Position versetzt.</font><br>
          kopfPos(pos);
          <font color="blue">// Falls erfüllt: Im String "zeichen", wird die entsprechende Position durch den neuen "char" ersetzt und das Band wird mithilfe von "bandZeichen(pos)" in der entsprechenden Position aktualisiert und die Funktion des nachfolgenden Knotens mit Position "pos + 1" (da das Band eine Position nach Rechts bewegt wird) wird aufgerufen.</font><br>
          if(zeichen[pos] == 'B'){<br>
            zeichen = zeichen.replace('B', '⌴');<br>
            bandZeichen(pos);<br>
            nodeQ1(pos + 1);<br>
          } <br>
          <font color="blue">// Falls nicht erfüllt: Das Band und der Graph werden an der entsprechenden Position farblich rot markiert, da der Input nicht angenommen wurde und damit nicht der Reber-Grammatik entspricht.</font><br>
          else{<br>
            fill(220, 20, 20);<br>
            rect(50 + (pos * 30), greeting.y + 60, 30, 30);<br>
            fill(255);<br>
            text(zeichen[pos], 58 + (pos * 30), 132);<br>
            markQ(0, false);<br>
          }<br>
        }<br><br><br><br>
        <font color="blue">// Visualisierung</font><br>
        <font color="blue">// Ähnlich hierzu wurden alle anderen Canvas-Strukturen erstellt. Bei jeder Änderung wurde die Fläche mit weiß übermalt und eine neue Struktur wurde erzeugt.</font><br>
        function kopfPos(pos){<br>
          stroke(255);<br>
          fill(255);<br>
          <font color="blue">// Die Fläche wird mit einem weißen Kasten "übermalt".</font><br>
          rect(50, 141, 600, 90);<br>
          <br>
          stroke(0);<br>
          fill(0);<br>
          <font color="blue">// Linien für den Kasten und den Pfeil</font><br>
          line(50 + (pos * 30), 200, 80 + (pos * 30), 200);<br>
          line(50 + (pos * 30), 230, 80 + (pos * 30), 230);<br>
          line(50 + (pos * 30), 200, 50 + (pos * 30), 230);<br>
          line(80 + (pos * 30), 200, 80 + (pos * 30), 230);<br>
          <br>
          line(65 + (pos * 30), 200, 65 + (pos * 30), 148);<br>
          <br>
          push();<br>
          <font color="blue">// Pfeilrichtung</font><br>
          var angle = atan2(90, 0); <br>
          translate(65 + (pos * 30), 152); <br>
          rotate(angle-HALF_PI); <br>
          triangle(-5, 7, 5, 7, 0, -15/2); <br>
          pop();<br>
        }<br>
        <br>
        <br>
        <br>
        <font color="blue">// Entsprechend "pos" wird in der Visualisierung des Bandes die Position aktualisiert.</font><br>
        function bandZeichen(pos){<br>
          textSize(20);<br>
          stroke(0);<br>
          fill(255);<br>
          rect(50 + (pos * 30), greeting.y + 60, 30, 30);<br>
        
          stroke(255);<br>
          fill(0);<br>
          text(zeichen[pos], 58 + (pos * 30), 132);<br>
        }
        </code>
    </p> 
  </main>
</body>

</html>